local number_to_color = {
    [1] = "medic_heal";
    [2] = "friendly";
    [3] = "highlight_character";
};

if CivilianHighlighter._data.enabled == "on" then
    local marked_civilians = {};

    if managers.groupai then
        is_stealth = managers.groupai:state():whisper_mode();
        if not is_stealth and managers.player and managers.player:player_unit() then
            local from = managers.player:player_unit():movement():m_head_pos();
            local range = alive(managers.player:player_unit():inventory():equipped_unit()) and managers.player:player_unit():inventory():equipped_unit():base():has_range_distance_scope() and 20000 or 4000;
            local to = managers.player:player_unit():camera():forward() * range;
            mvector3.add(to, from);
            
            local hits = World:raycast_all("ray", from, to, "sphere_cast_radius", 300, "disable_inner_ray", "slot_mask", managers.slot:get_mask("civilians"));
            for _, hit in pairs(hits) do
                table.insert(marked_civilians, hit.unit);
                hit.unit:contour():add(number_to_color[CivilianHighlighter._data.contour_color], true);
            end;
        end;
    end;

    if managers.enemy then
        for _, civilian_data in pairs(managers.enemy:all_civilians()) do
            if not is_stealth and managers.player and managers.player:player_unit() then
                local player_distance = mvector3.distance(managers.player:player_unit():movement():m_pos(), civilian_data.unit:movement():m_pos());
                if player_distance <= 2000 then
                    civilian_data.unit:contour():add(number_to_color[CivilianHighlighter._data.contour_color], true);
                else
                    if not marked_civilians[civilian_data.unit] then
                        civilian_data.unit:contour():remove(number_to_color[CivilianHighlighter._data.contour_color], true);
                    end;
                end;
            else
                civilian_data.unit:contour():remove(number_to_color[CivilianHighlighter._data.contour_color], true);
            end;
        end;
    end;
else
    if managers.enemy then
        for _, civilian_data in pairs(managers.enemy:all_civilians()) do
            civilian_data.unit:contour():remove(number_to_color[CivilianHighlighter._data.contour_color], true);
        end;
    end;
end;