_G.CivilianHighlighter = _G.CivilianHighlighter or {};
CivilianHighlighter._path = ModPath .. "OptionsMenu.txt";
CivilianHighlighter._save_path = SavePath .. "CivilianHighlighterData.txt";
CivilianHighlighter._loc_path = ModPath .. "Localization/";
CivilianHighlighter._data = {};

function CivilianHighlighter:save()
    local find_file = io.open(self._save_path, "w");
    if find_file then
        local encoded_options = json.encode(CivilianHighlighter._data);
        find_file:write(encoded_options); find_file:close();
    end;
end;

function CivilianHighlighter:load()
    local find_file = io.open(CivilianHighlighter._save_path, "r");
    if find_file then
        local decoded_options = json.decode(find_file:read("*all"));
        self._data = decoded_options; find_file:close();
    end;
end;

function CivilianHighlighter:find_localization_file()
    if BLT and BLT.Localization then
        local find_language_file = CivilianHighlighter._loc_path .. BLT.Localization:get_language().language .. "txt";
        if find_language_file and io.file_is_readable(find_language_file) then
            return find_language_file;
        end;
    end;

    return CivilianHighlighter._loc_path .. "en.txt";
end;

Hooks:AddHook("LocalizationManagerPostInit", "CivilianHighlighter_LocalizationManagerPostInit",
    function(self)
        self:load_localization_file(CivilianHighlighter:find_localization_file(), false);
    end
);

Hooks:Add("MenuManagerInitialize", 'CivilianHighlighter_MenuManagerInitialize',
    function()
        MenuCallbackHandler.toggle_civilian_highlighter_contour_color = function(self, item)
            CivilianHighlighter._data.contour_color = item:value(); CivilianHighlighter:save();
        end;

        MenuCallbackHandler.toggle_civilian_highlighter_enabled = function(self, item)
            CivilianHighlighter._data.enabled = item:value(); CivilianHighlighter:save();
        end;

        CivilianHighlighter:load(); MenuHelper:LoadFromJsonFile(CivilianHighlighter._path, CivilianHighlighter, CivilianHighlighter._data);
    end
);